local Graze_Next_pos = Vector3()
local Graze_mul_direction = Vector3()
local Graze_Z = 100
local Graze_Max_distance = 20000
local Graze_Max_Loop = 200

local mvec_to = Vector3()
local mvec_spread_direction = Vector3()
local mvec1 = Vector3()

if not Graze_Shoot_Event_Bool then
	Graze_Shoot_Event = true
	Hooks:PostHook(RaycastWeaponBase, "_fire_raycast", "Graze_Shoot_Event", function(self, user_unit, from_pos, direction, dmg_mul, shoot_player, spread_mul, autohit_mul, suppr_mul, shoot_through_data)
		if self:is_single_shot() and self:is_category("snp") and user_unit and direction then
			mvec_to = Vector3()
			mvec_spread_direction = Vector3()
			mvec1 = Vector3()
			Graze_Next_pos = Vector3()
			Graze_mul_direction = Vector3()
			
			local spread_x, spread_y = self:_get_spread(user_unit)
			local ray_distance = Graze_Max_distance
			local right = direction:cross(Vector3(0, 0, 1)):normalized()
			local up = direction:cross(right):normalized()
			local theta = math.random() * 360
			local ax = math.sin(theta) * math.random() * spread_x * (spread_mul or 1)
			local ay = math.cos(theta) * math.random() * spread_y * (spread_mul or 1)
		
			mvector3.set(mvec_spread_direction, direction)
			mvector3.add(mvec_spread_direction, right * math.rad(ax))
			mvector3.add(mvec_spread_direction, up * math.rad(ay))
			mvector3.set(mvec_to, mvec_spread_direction)
			mvector3.multiply(mvec_to, ray_distance)
			mvector3.add(mvec_to, from_pos)
		
			local damage = self:_get_current_damage(dmg_mul * 0.35)

			mvector3.set(Graze_mul_direction, direction)
			mvector3.multiply(Graze_mul_direction, 10)
			mvector3.add(Graze_Next_pos, from_pos)
			mvector3.add(Graze_Next_pos, Graze_mul_direction)
			local i = 1
			local touch = {}
			while mvector3.distance(from_pos, Graze_Next_pos) < Graze_Max_distance and i < Graze_Max_Loop do
				local units = World:find_units("sphere", Graze_Next_pos, Graze_Z, self._bullet_slotmask) or {}
				for _, unit in pairs(units) do
					if not unit or not alive(unit) or not unit:base() or type(unit:base()._tweak_table) ~= "string" or not managers.enemy:is_enemy(unit) or not unit:character_damage() or unit:character_damage()._immortal or unit:character_damage():dead() then
					
					else
						touch["TOUCH_"..tostring(unit:key())] = unit
					end
				end
				i = i + 1
				mvector3.set(Graze_mul_direction, direction)
				mvector3.multiply(Graze_mul_direction, 10 * i)
				mvector3.add(Graze_Next_pos, Graze_mul_direction)
			end
			for _, unit in pairs(touch) do
				unit:character_damage():damage_explosion({
					variant = "explosion",
					damage = damage,
					weapon_unit = self._unit,
					attacker_unit = user_unit,
					col_ray = {
						ray = Vector3(1, 0, 0),
						position = unit:position()
					}
				})
			end
		end
	end)
end